/**
 * POCDMT000040EncompassingEncounter.java
 *
 * File generated from the cdaepsos3::POCDMT000040EncompassingEncounter uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos3;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040EncompassingEncounter.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.EncompassingEncounter", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"effectiveTime",
	"dischargeDispositionCode",
	"responsibleParty",
	"encounterParticipant",
	"location",
	"classCode",
	"moodCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.EncompassingEncounter")
public class POCDMT000040EncompassingEncounter implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> id;
	@XmlElement(name = "code", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE code;
	@XmlElement(name = "effectiveTime", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.IVLTS effectiveTime;
	@XmlElement(name = "dischargeDispositionCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE dischargeDispositionCode;
	@XmlElement(name = "responsibleParty", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ResponsibleParty responsibleParty;
	@XmlElement(name = "encounterParticipant", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040EncounterParticipant> encounterParticipant;
	@XmlElement(name = "location", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Location location;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.ActClass classCode;
	@XmlAttribute(name = "moodCode")
	public net.ihe.gazelle.voc.ActMood moodCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public List<net.ihe.gazelle.datatypes.II> getId() {
		if (id == null) {
	        id = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(List<net.ihe.gazelle.datatypes.II> id) {
	    this.id = id;
	}
	
	
	
	/**
	 * Add a id to the id collection.
	 * @param id_elt Element to add.
	 */
	public void addId(net.ihe.gazelle.datatypes.II id_elt) {
	    this.getId().add(id_elt);
	}
	
	/**
	 * Remove a id to the id collection.
	 * @param id_elt Element to remove
	 */
	public void removeId(net.ihe.gazelle.datatypes.II id_elt) {
	    this.getId().remove(id_elt);
	}
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.datatypes.CE getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.datatypes.CE code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return effectiveTime.
	 * @return effectiveTime
	 */
	public net.ihe.gazelle.datatypes.IVLTS getEffectiveTime() {
	    return effectiveTime;
	}
	
	/**
	 * Set a value to attribute effectiveTime.
	 * @param effectiveTime.
	 */
	public void setEffectiveTime(net.ihe.gazelle.datatypes.IVLTS effectiveTime) {
	    this.effectiveTime = effectiveTime;
	}
	
	
	
	
	/**
	 * Return dischargeDispositionCode.
	 * @return dischargeDispositionCode
	 */
	public net.ihe.gazelle.datatypes.CE getDischargeDispositionCode() {
	    return dischargeDispositionCode;
	}
	
	/**
	 * Set a value to attribute dischargeDispositionCode.
	 * @param dischargeDispositionCode.
	 */
	public void setDischargeDispositionCode(net.ihe.gazelle.datatypes.CE dischargeDispositionCode) {
	    this.dischargeDispositionCode = dischargeDispositionCode;
	}
	
	
	
	
	/**
	 * Return responsibleParty.
	 * @return responsibleParty
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ResponsibleParty getResponsibleParty() {
	    return responsibleParty;
	}
	
	/**
	 * Set a value to attribute responsibleParty.
	 * @param responsibleParty.
	 */
	public void setResponsibleParty(net.ihe.gazelle.cdaepsos3.POCDMT000040ResponsibleParty responsibleParty) {
	    this.responsibleParty = responsibleParty;
	}
	
	
	
	
	/**
	 * Return encounterParticipant.
	 * @return encounterParticipant
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040EncounterParticipant> getEncounterParticipant() {
		if (encounterParticipant == null) {
	        encounterParticipant = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040EncounterParticipant>();
	    }
	    return encounterParticipant;
	}
	
	/**
	 * Set a value to attribute encounterParticipant.
	 * @param encounterParticipant.
	 */
	public void setEncounterParticipant(List<net.ihe.gazelle.cdaepsos3.POCDMT000040EncounterParticipant> encounterParticipant) {
	    this.encounterParticipant = encounterParticipant;
	}
	
	
	
	/**
	 * Add a encounterParticipant to the encounterParticipant collection.
	 * @param encounterParticipant_elt Element to add.
	 */
	public void addEncounterParticipant(net.ihe.gazelle.cdaepsos3.POCDMT000040EncounterParticipant encounterParticipant_elt) {
	    this.getEncounterParticipant().add(encounterParticipant_elt);
	}
	
	/**
	 * Remove a encounterParticipant to the encounterParticipant collection.
	 * @param encounterParticipant_elt Element to remove
	 */
	public void removeEncounterParticipant(net.ihe.gazelle.cdaepsos3.POCDMT000040EncounterParticipant encounterParticipant_elt) {
	    this.getEncounterParticipant().remove(encounterParticipant_elt);
	}
	
	/**
	 * Return location.
	 * @return location
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Location getLocation() {
	    return location;
	}
	
	/**
	 * Set a value to attribute location.
	 * @param location.
	 */
	public void setLocation(net.ihe.gazelle.cdaepsos3.POCDMT000040Location location) {
	    this.location = location;
	}
	
	
	
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.ActClass getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.ActClass classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return moodCode.
	 * @return moodCode
	 */
	public net.ihe.gazelle.voc.ActMood getMoodCode() {
	    return moodCode;
	}
	
	/**
	 * Set a value to attribute moodCode.
	 * @param moodCode.
	 */
	public void setMoodCode(net.ihe.gazelle.voc.ActMood moodCode) {
	    this.moodCode = moodCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos3");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.EncompassingEncounter").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040EncompassingEncounter pOCDMT000040EncompassingEncounter, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040EncompassingEncounter != null){
   			cvm.validate(pOCDMT000040EncompassingEncounter, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040EncompassingEncounter.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040EncompassingEncounter.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040EncompassingEncounter.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II id: pOCDMT000040EncompassingEncounter.getId()){
					net.ihe.gazelle.datatypes.II.validateByModule(id, _location + "/id[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040EncompassingEncounter.getCode(), _location + "/code", cvm, diagnostic);
			net.ihe.gazelle.datatypes.IVLTS.validateByModule(pOCDMT000040EncompassingEncounter.getEffectiveTime(), _location + "/effectiveTime", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040EncompassingEncounter.getDischargeDispositionCode(), _location + "/dischargeDispositionCode", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos3.POCDMT000040ResponsibleParty.validateByModule(pOCDMT000040EncompassingEncounter.getResponsibleParty(), _location + "/responsibleParty", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040EncounterParticipant encounterParticipant: pOCDMT000040EncompassingEncounter.getEncounterParticipant()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040EncounterParticipant.validateByModule(encounterParticipant, _location + "/encounterParticipant[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			net.ihe.gazelle.cdaepsos3.POCDMT000040Location.validateByModule(pOCDMT000040EncompassingEncounter.getLocation(), _location + "/location", cvm, diagnostic);
    	}
    }

}